uglify = require('uglify-js').minify
bus = require('statebus/server')()
#bus.honk = true
app = require('express')()
fs = require('fs')
request = require('request')


port = 1980
if fs.existsSync('certs')
  # Load with TLS/SSL
  console.log('Encryption ON')
  ssl_options =
    ca: if fs.existsSync('certs/certificate-bundle') then require('split-ca')('certs/certificate-bundle')
    key:  fs.readFileSync('certs/private-key')
    cert: fs.readFileSync('certs/certificate')
    ciphers: ("ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384"\
          + ":ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256"\
          + ":ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256"\
          + ":HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA")
    honorCipherOrder: true
  server = require('https').createServer(ssl_options, app)
  if process.getuid() == 0 then port = 443

else
  # Load unencrypted server
  console.log('Encryption off')
  server = require('http').createServer(app)
  ssl_options = undefined
  if process.getuid() == 0 then port = 80

server.listen(port, () ->
  host = server.address().address
  port = server.address().port
  console.log('Listening at https://%s:%s', host, port)

  # Now undo the sudo
  # Find out which user used sudo through the environment variable
  uid = parseInt(process.env.SUDO_UID)
  # Set our server's uid to that user
  if uid then process.setuid(uid)
  console.log('Server\'s UID is now ' + process.getuid())
)


send_code = (key) ->
  (req, res) ->
    cb = (o) ->
      console.log('Uploading', o.key)
      res.setHeader('content-type', 'application/javascript')
      res.end('' + o.code)
      bus.forget(key, cb)
    fetch(key, cb)

send_sb_code = (name) -> send_code("/code/statebus/#{name}")

bus('/code/statebus/*').on_fetch = (key) ->
  # Handle v=3 and v=3.0
  key = key.replace(/\?v=?3(\.0)?$/, '')

  console.log('Downloading', key)
  name = key.replace(/^\/code\/statebus\//, '')
  minify = name.indexOf('.min.js') == name.length - 7
  if minify
    name = name.slice(0, name.length-7) + '.js'
  url = "https://raw.githubusercontent.com/invisible-college/statebus/master/#{name}"
  #console.log(url)
  request(url, (error, response, body) ->
    if error then return
    if minify then body = uglify(body, {fromString: true}).code
    bus.pub({key:key,code:body})
  )
  undefined

for c in 'statebus statebus.min client client.min'.split(' ')
  app.get("/#{c}.js", send_sb_code("#{c}.js"))

for c in 'react coffee sockjs'.split(' ')
  app.get("/extras/#{c}.js", send_sb_code("extras/#{c}.js"))
  app.get("/libraries/#{c}.js", send_sb_code("libraries/#{c}.js"))

app.get("/code/*", (req, res) -> send_code(req.path)(req, res))
app.get("/helo", (req, res) -> 
  console.log('helo!')
  res.setHeader('content-type', 'application/javascript')
  res.end('helo!')
)

User = (client, conn) ->
  client.serves_auth(conn, bus)
  client.route_defaults_to(bus)
bus.serve({port: 3003, client_definition: User})
